module mod_flux

  use mod_precision
  
contains

  function fluxp(rho,ux,uy,e,p,t,a,b,nx,ny) 
    
    implicit none

    real(pr), intent(in) :: rho,ux,uy,e,p,t,a,b,nx,ny
    real(pr), dimension(1:4) :: fluxp

    real(pr) :: un,ut,f1,f2,f3,f4

    un=nx*ux+ny*uy
    ut=-ny*ux+nx*uy

    if (un>=b) then
       
       f1=rho*un
       f2=rho*un**2+p
       f3=ut*f1
       f4=(e+p)*un

    elseif (un<=-b) then

       f1=0._pr
       f2=0._pr
       f3=0._pr
       f4=0._pr

    else

       f1=2._pr*a*b**2*(un+b)**2
       f2=4._pr/3._pr*a*b**2*(un+b)**3
       f3=ut*f1
       f4=a*b**2/2._pr*(un+b)**2*(un**2+2._pr*un*b+2*ut**2+7._pr/3._pr*b**2)

    end if

    fluxp(1)=f1
    fluxp(2)=nx*f2-ny*f3
    fluxp(3)=ny*f2+nx*f3
    fluxp(4)=f4

  end function fluxp

  function fluxm(rho,ux,uy,e,p,t,a,b,nx,ny) 
    
    implicit none

    real(pr), intent(in) :: rho,ux,uy,e,p,t,a,b,nx,ny
    real(pr), dimension(1:4) :: fluxm

    fluxm=-fluxp(rho,ux,uy,e,p,t,a,b,-nx,-ny) 

  end function fluxm
  

end module mod_flux


